<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Select a [`ValueParser`] implementation from the intended type"><meta name="keywords" content="rust, rustlang, rust-lang, value_parser"><title>value_parser in clap - Rust</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../normalize.css"><link rel="stylesheet" type="text/css" href="../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../dark.css" disabled><link rel="stylesheet" type="text/css" href="../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../storage.js"></script><script defer src="sidebar-items.js"></script><script defer src="../main.js"></script><noscript><link rel="stylesheet" href="../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../favicon.svg"></head><body class="rustdoc macro"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../clap/index.html"><div class="logo-container"><img src="https://raw.githubusercontent.com/clap-rs/clap/master/assets/clap.png" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../clap/index.html"><div class="logo-container">
                    <img src="https://raw.githubusercontent.com/clap-rs/clap/master/assets/clap.png" alt="logo"></div>
        </a><div class="sidebar-elems"><h2 class="location"><a href="index.html">In clap</a></h2></div></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../clap/index.html">
                        <img src="https://raw.githubusercontent.com/clap-rs/clap/master/assets/clap.png" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="main-heading">
    <h1 class="fqn"><span class="in-band">Macro <a href="index.html">clap</a>::<wbr><a class="macro" href="#">value_parser</a><button id="copy-path" onclick="copy_path(this)" title="Copy item path to clipboard"><img src="../clipboard.svg" width="19" height="18" alt="Copy item path"></button></span></h1><span class="out-of-band"><a class="srclink" href="../src/clap/builder/value_parser.rs.html#2043-2049">source</a> · <a id="toggle-all-docs" href="javascript:void(0)" title="collapse all docs">[<span class="inner">&#x2212;</span>]</a></span></div><div class="docblock item-decl"><div class="example-wrap"><pre class="rust macro"><code><span class="macro">macro_rules!</span> <span class="ident">value_parser</span> {
    (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">name</span>:<span class="ident">ty</span>) =&gt; { ... };
}</code></pre></div>
</div><details class="rustdoc-toggle top-doc" open><summary class="hideme"><span>Expand description</span></summary><div class="docblock"><p>Select a <a href="builder/struct.ValueParser.html" title="ValueParser"><code>ValueParser</code></a> implementation from the intended type</p>
<p>To register a custom type with this macro, implement <a href="builder/trait.ValueParserFactory.html" title="ValueParserFactory"><code>ValueParserFactory</code></a>.</p>
<h2 id="example"><a href="#example">Example</a></h2>
<p>Usage:</p>

<div class="example-wrap"><pre class="rust rust-example-rendered"><code><span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">cmd</span> <span class="op">=</span> <span class="ident">clap::Command::new</span>(<span class="string">&quot;raw&quot;</span>)
    .<span class="ident">arg</span>(
        <span class="ident">clap::Arg::new</span>(<span class="string">&quot;output&quot;</span>)
            .<span class="ident">value_parser</span>(<span class="macro">clap::value_parser!</span>(<span class="ident">PathBuf</span>))
            .<span class="ident">required</span>(<span class="bool-val">true</span>)
    );

<span class="kw">let</span> <span class="ident">m</span> <span class="op">=</span> <span class="ident">cmd</span>.<span class="ident">try_get_matches_from_mut</span>([<span class="string">&quot;cmd&quot;</span>, <span class="string">&quot;file.txt&quot;</span>]).<span class="ident">unwrap</span>();
<span class="kw">let</span> <span class="ident">port</span>: <span class="kw-2">&amp;</span><span class="ident">PathBuf</span> <span class="op">=</span> <span class="ident">m</span>.<span class="ident">get_one</span>(<span class="string">&quot;output&quot;</span>)
    .<span class="ident">expect</span>(<span class="string">&quot;required&quot;</span>);
<span class="macro">assert_eq!</span>(<span class="ident">port</span>, <span class="ident">Path::new</span>(<span class="string">&quot;file.txt&quot;</span>));</code></pre></div>
<p>Supported types:</p>

<div class="example-wrap"><pre class="rust rust-example-rendered"><code><span class="comment">// Built-in types</span>
<span class="kw">let</span> <span class="ident">parser</span> <span class="op">=</span> <span class="macro">clap::value_parser!</span>(<span class="ident">String</span>);
<span class="macro">assert_eq!</span>(<span class="macro">format!</span>(<span class="string">&quot;{:?}&quot;</span>, <span class="ident">parser</span>), <span class="string">&quot;ValueParser::string&quot;</span>);
<span class="kw">let</span> <span class="ident">parser</span> <span class="op">=</span> <span class="macro">clap::value_parser!</span>(<span class="ident">std::ffi::OsString</span>);
<span class="macro">assert_eq!</span>(<span class="macro">format!</span>(<span class="string">&quot;{:?}&quot;</span>, <span class="ident">parser</span>), <span class="string">&quot;ValueParser::os_string&quot;</span>);
<span class="kw">let</span> <span class="ident">parser</span> <span class="op">=</span> <span class="macro">clap::value_parser!</span>(<span class="ident">std::path::PathBuf</span>);
<span class="macro">assert_eq!</span>(<span class="macro">format!</span>(<span class="string">&quot;{:?}&quot;</span>, <span class="ident">parser</span>), <span class="string">&quot;ValueParser::path_buf&quot;</span>);
<span class="kw">let</span> <span class="ident">parser</span> <span class="op">=</span> <span class="macro">clap::value_parser!</span>(<span class="ident">u16</span>).<span class="ident">range</span>(<span class="number">3000</span>..);
<span class="macro">assert_eq!</span>(<span class="macro">format!</span>(<span class="string">&quot;{:?}&quot;</span>, <span class="ident">parser</span>), <span class="string">&quot;RangedI64ValueParser { bounds: (Included(3000), Included(65535)), target: PhantomData }&quot;</span>);
<span class="kw">let</span> <span class="ident">parser</span> <span class="op">=</span> <span class="macro">clap::value_parser!</span>(<span class="ident">u64</span>).<span class="ident">range</span>(<span class="number">3000</span>..);
<span class="macro">assert_eq!</span>(<span class="macro">format!</span>(<span class="string">&quot;{:?}&quot;</span>, <span class="ident">parser</span>), <span class="string">&quot;RangedU64ValueParser { bounds: (Included(3000), Unbounded), target: PhantomData }&quot;</span>);

<span class="comment">// FromStr types</span>
<span class="kw">let</span> <span class="ident">parser</span> <span class="op">=</span> <span class="macro">clap::value_parser!</span>(<span class="ident">usize</span>);
<span class="macro">assert_eq!</span>(<span class="macro">format!</span>(<span class="string">&quot;{:?}&quot;</span>, <span class="ident">parser</span>), <span class="string">&quot;_AnonymousValueParser(ValueParser::other(usize))&quot;</span>);

<span class="comment">// ValueEnum types</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Copy</span>, <span class="ident">Clone</span>, <span class="ident">Debug</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>)]</span>
<span class="kw">enum</span> <span class="ident">ColorChoice</span> {
    <span class="ident">Always</span>,
    <span class="ident">Auto</span>,
    <span class="ident">Never</span>,
}
<span class="kw">impl</span> <span class="ident">clap::ValueEnum</span> <span class="kw">for</span> <span class="ident">ColorChoice</span> {
    <span class="comment">// ...</span>
}
<span class="kw">let</span> <span class="ident">parser</span> <span class="op">=</span> <span class="macro">clap::value_parser!</span>(<span class="ident">ColorChoice</span>);
<span class="macro">assert_eq!</span>(<span class="macro">format!</span>(<span class="string">&quot;{:?}&quot;</span>, <span class="ident">parser</span>), <span class="string">&quot;EnumValueParser(PhantomData)&quot;</span>);</code></pre></div>
</div></details></section></div></main><div id="rustdoc-vars" data-root-path="../" data-current-crate="clap" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>